<?php

class parameter_integrator
{
	var $request_template;
	var $current_order;
	var $request_version = "1.0";
	// all request parameters
	var $security_sender;
	var $mode;
	var $transaction_channel;
	var $source;
	var $response;
	var $response_url;
	var $user_login;
	var $user_pwd;
	var $identification_transaction;
	var $identification_reference;
	var $identification_unique;
	var $identification_short;
	var $identification_shopper;
	var $payment_code;
	var $payment_type;
	var $payment_previous_amount;
	var $payment_amount;
	var $payment_currency;
	var $payment_usage;
	var $payment_descriptor;
	var $payment_presentation_amount;
	var $payment_presentation_currency;
	var $payment_presentation_usage;
	var $payment_presentation_descriptor;
	var $account_holder;
	var $account_number;
	var $account_id;
	var $account_password;
	var $account_brand;
	var $account_expiry_month;
	var $account_expiry_year;
	var $account_start_month;
	var $account_start_year;
	var $account_cardissue_number;
	var $account_verification;
	var $account_bank;
	var $account_bankname;
	var $account_iban;
	var $account_bic;
	var $account_country;
	var $account_limit;
	var $account_identification;
	var $account_balance;
	var $account_registration_url;
	var $customer_name_salutation;
	var $customer_name_title;
	var $customer_name_given;
	var $customer_name_family;
	var $customer_name_company;
	var $customer_address_street;
	var $customer_address_zip;
	var $customer_address_city;
	var $customer_address_state;
	var $customer_address_country;
	var $customer_contact_phone;
	var $customer_contact_mobile;
	var $customer_contact_email;
	var $customer_contact_ip;
	var $customer_details_paper;
	var $customer_details_identity;
	var $customer_avs_instruction;
	var $customer_avs_rejectionpolicy;
	var $order;
	var $authentication_type;
	var $authentication_parameter;
	var $authentication_resultindicator;
	var $authentication_eci;
	var $authentication_verification;
	var $authentication_xid;
	var $reftx_authentication_eci;
	var $reftx_authentication_verification;
	var $reftx_authentication_xid;
	var $anaylisis_criterion;
	
	// Hint: Do we really need this ? 
    var $threedsecure_enabled; 
    var $threedsecure_threedsystem_type;
    var $threedsecure_threedsystem_acquirer_bin;
	var $threedsecure_threedsystem_merchant_id;
    var $threedsecure_threedsystem_merchant_password;
    var $threedsecure_merchant_name;
    var $threedsecure_merchant_url;
    var $threedsecure_merchant_country;
    
	var $frontend_response_url;
	var $frontend_session_id;

	function marshall()
	{
		return;
	}

	function unmarshall()
	{
		return;
	}

	function generate_unique_id ($_key = '')
	{
		$chars = uniqid(mt_rand());

		$identification['short_id'] = substr($chars, 0, 4) .".";
		$identification['short_id'] .= substr($chars, 4, 4) .".";
		$identification['short_id'] .= substr($chars, 8, 4);

		$identification['uu_id'] = md5(uniqid(mt_rand(), true));
		
		if ($_key == 'short_id' || $_key == 'uu_id')
			return $identification[$_key];
			
		return $identification;
	}
	
	function set_parameter_by_prefix ($prefix, $data)
	{
		$var = $prefix. "_". $k;
		foreach ($data as $k=>$v)
		{
			if (array_key_exists($k, get_object_vars($this)))
			{
				$this->{$var} = $v;
			}
		}
	}

	function set_payment_amount ($total, $aux='payment_presentation')
	{
		global $currencies;
		$aux_currency = $aux. "_currency";
		if (is_null($this->{$aux_currency}))
		{
			$this->{$aux_currency} = EURO_CURRENCY;
		}
		
		if (!zen_currency_exists($this->{$aux_currency}))
		{
			$this->{$aux_currency} = zen_currency_exists(EURO_CURRENCY) ? EURO_CURRENCY : DEFAULT_CURRENCY;
		}
		
		$selected_currency = $this->{$aux_currency};
		$actual_currency = $_SESSION['currency'];
		$total_price = $total * ($currencies->get_value($selected_currency) / $currencies->get_value($actual_currency));
		$decimal_place = $currencies->get_decimal_places($selected_currency);
		
		$this->{$aux."_amount"} = number_format($total_price, $decimal_place, '.', '');
	}
}

?>
