<?php

define("ACKNOWLEDGE_RETURN_CODE_SUCCESS", '000.000.000');
define("ACKNOWLEDGE_RETURN_CODE_WAITING", '000.200.000');
define("ACKNOWLEDGE_POST_VALIDATION", 'ACK');
define("ACKNOWLEDGE_PROCESSING_RESULT", 'ACK');
define("XPATH_RESULT_ASYNC_RESPONSE", "/Response/Transaction/Processing/Result");
define("XPATH_RETURN_ASYNC_RESPONSE", "/Response/Transaction/Processing/Return/@code");
define("XPATH_RESULT_SYNC_RESPONSE", "/Response/Transaction/Processing/Result");
define("XPATH_RETURN_SYNC_RESPONSE", "/Response/Transaction/Processing/Return/@code");
define("XPATH_RETURN_SYNC_RESPONSE_MESSAGE", "/Response/Transaction/Processing/Return");
define("XPATH_RESPONSE_URLREDIRECTEDTO", "/Response/Transaction/Processing/Redirect/@url");
define("XPATH_RESPONSE_PARAMETERS", "/Response/Transaction/Processing/Redirect/Parameter");
define("XPATH_FRONTEND_SESSIONID", "/Response/Transaction/Frontend/SessionID");

define("EURO_CURRENCY", "EUR");
define("FILENAME_CHECKOUT_PAYMENT_ERROR", 'response_error');
define("FILENAME_CHECKOUT_TRANSACTION_FRAME", 'checkout_transaction_frame.php');
define("FILENAME_CHECKOUT_TRANSACTION_POPUP", 'checkout_transaction_popup.php');
define("FILENAME_CHECKOUT_REDIRECT", 'checkout_redirect');
define("FILENAME_REDIRECT_URL", 'redirect_url.php');
define("FILENAME_RESPONSE", 'response');
define("FILENAME_RESPONSE_REDIRECT", 'response_redirect');
define("TEMPLATE_RESPONSE_OT", 'response_ot.html');
define("DEFAULT_FRONTEND_MODE", "DEFAULT");
define("ASYNC_FRONTEND_MODE", "ASYNC");
define("WPFLIGHT_FRONTEND_MODE", "WPF_LIGHT");
define("WPFDIRECT_FRONTEND_MODE", "WPF_DIRECT");
define("PRESENTATION_USAGE", "Order Number");
define("SESKEY_FRAME_URL", "FRAME_URL");
define("SESKEY_OT_URL", "OT_URL");
define("SESKEY_URL_REDIRECTEDTO", "URL_REDIRECTEDTO");
define("SERVER_REDIRECT", 'server');

define("FILENAME_ASYNCPOST_RESPONSE", 'asyncpost_response.php');
define("FILENAME_ASYNCPOST_CHECKOUT_REDIRECT", 'asyncpost_checkout_confirmation.php');
define("FILENAME_WPF_DIRECT_CHECKOUT_REDIRECT", 'wpf_direct_checkout_confirmation.php');

define('COOKIEKEY_CLEARDATA_AFTER_PAYMENT', 'clearData');
define('COOKIEKEY_ALTERNATEURL_SUCCESS', 'altUrlS');
define('COOKIEKEY_ALTERNATEURL_FAILED', 'altUrlF');
define('COOKIEKEY_ALTERNATEURL_CONTINUE', 'altUrlC');

define("MODE_WPFALL", "wpf_all");
define("MODE_WPFEACH", "wpf_each");
define("MODE_WPFLIGHT", "wpf_light");
define("MODE_WPFDIRECT", "wpf_direct");
define("MODE_PAYPIPE", "paypipe");
define("MODE_HOSTED_PAYMENT_PAGE", "hpp");
define("MODE_XML", "xml");
define("MODE_POST_REQUEST", "post");
define("MODE_ASYNCPOST_REQUEST", "asyncpost");
define("MODE_MOTO_REQUEST", "moto");

// METHOD
define("BANKTRANSFER_METHOD_DIRECTDEBIT", "DD");
define("BANKTRANSFER_METHOD_CREDITTRANSFER", "CT");
define("BANKTRANSFER_METHOD_PREPAYMENT", "PP");
define("BANKTRANSFER_METHOD_INVOICE", "IV");
define("CARDPAYMENT_METHOD_CREDITCARD", "CC");
define("CARDPAYMENT_METHOD_DEBITCARD", "DC");
define("ONLINEPAYMENT_METHOD_WALLETPAYMENT", "VA");
define("ONLINEPAYMENT_METHOD_ONLINETRANSFER", "OT");
define("OTHER_METHOD_USERACCOUNT", "UA");
define("OTHER_METHOD_VIRTUALACCOUNT", "VA");
define("OTHER_METHOD_RISKMANAGEMENT", "RM");
define("OTHER_METHOD_COLLECTION", "CL");
// TYPE
define("PAYMENT_TYPE_PREAUTHORISATION", "PA");
define("PAYMENT_TYPE_DEBIT", "DB");
define("PAYMENT_TYPE_CAPTURE", "CP");
define("PAYMENT_TYPE_CREDIT", "CD");
define("PAYMENT_TYPE_REVERSAL", "RV");
define("PAYMENT_TYPE_REFUND", "RF");
define("PAYMENT_TYPE_REBILL", "RB");
define("PAYMENT_TYPE_CHARGEBACK", "CB");
define("PAYMENT_TYPE_RECEIPT", "RC");
define("PAYMENT_TYPE_3D", "TD");
define("PAYMENT_TYPE_RECONCILIATION", "RL");
define("REGISTRATION_TYPE_REGISTRATION", "RG");
define("REGISTRATION_TYPE_REREGISTRATION", "RR");
define("REGISTRATION_TYPE_DEREGISTRATION", "DR");
define("REGISTRATION_TYPE_CONFIRMATION", "CF");
define("SCHEDULING_TYPE_SCHEDULE", "SD");
define("SCHEDULING_TYPE_RESCHEDULE", "RS");
define("SCHEDULING_TYPE_DESCHEDULE", "DS");

define("REGEX_COMPLETE_URL", '/^(((http|ftp|https):\/\/){1}([a-zA-Z0-9_-]+)(\.[a-zA-Z0-9_-]+)+([\S,:\/\.\?=a-zA-Z0-9_-]+))$/is');
define("REGEX_BASIC_HTTP_URL", '/^https?:\/\/[a-zA-Z0-9._-]+\.[a-zA-Z]{2,4}/');
define("REGEX_3DSECURE_DYNAMIC_PART", '/\??(ndcid=[a-zA-Z0-9_.]+)\&(jsessionid=[a-zA-Z0-9_.]+)/');
define("RISKMANAGEMENT_AUTO", "AUTO");

define("WPFFRONTEND_ENABLE", 'true');
define("WPFFRONTEND_DISABLE", 'false');
define("WPFFRONTEND_POPUP_ENABLE", 'true');
define("WPFFRONTEND_POPUP_DISABLE", 'false');

define("CALLBACK_ERROR", TEXT_ERROR_SERVER);
define("TECHNICAL_ERROR", TEXT_ERROR_TECHNICAL);
define("TRANSACTION_ERROR", TEXT_ERROR_TRANSCATION);

//form input
define("BANK_HOLDER", "bank_holder");
define("BANK_NAME", "bank_name");
define("BANK_NUMBER", "bank_number");
define("BANK_COUNTRY", "bank_country");

define("CREDITCARD_INPUT_NUMBER", "acc_number");
define("CREDITCARD_INPUT_HOLDER", "acc_hol");
define("CREDITCARD_INPUT_VERIFICATION", "acc_ver");
define("CREDITCARD_INPUT_BRAND", "acc_bra");
define("CREDITCARD_INPUT_EXPIRY_MONTH", "acc_Month");
define("CREDITCARD_INPUT_EXPIRY_YEAR", "acc_Year");

define("CUSTOMER_GIVEN", "acc_given");
define("CUSTOMER_FAMILY", "acc_family");
define("CUSTOMER_CITY", "acc_city");
define("CUSTOMER_STATE", "acc_state");
define("CUSTOMER_STREET", "acc_street");
define("CUSTOMER_COUNTRY", "acc_country");
define("CUSTOMER_POSTCODE", "acc_zip");
define("CUSTOMER_EMAIL_ADDRESS", "acc_email");
define("CUSTOMER_TELEPHONE", "acc_phone");
define("CUSTOMER_MOBILE", "acc_mobile");

define("BRAND_TPAY_CALLPAY", "TPAY_CALL_AND_PAY");
define("BRAND_TPAY_CC", "TPAY_CC");
define("BRAND_TPAY_DD", "TPAY_DD");
define("BRAND_TPAY_INVOICE", "TPAY_INVOICE");
define("BRAND_TPAY_MICROMONEY", "TPAY_MICRO_MONEY");
define("BRAND_TPAY_PAYBYCALL", "TPAY_PAY_BY_CALL");

define("PARAMETER_CLASSES_XML", "xml_integrator,paypipe_integrator");
define("PARAMETER_CLASSES_WPF", "wpf_integrator,post_integrator");
define("PARAMETER_CLASSES_HPP", "hpp_integrator");

define("WPFKEY_POST_VALIDATION", "POST_VALIDATION");
define("WPFKEY_PROCESSING_RETURN", "PROCESSING_RETURN");
define("WPFKEY_PROCESSING_RETURN_CODE", "PROCESSING_RETURN_CODE");
define("WPFKEY_PROCESSING_RESULT", "PROCESSING_RESULT");
define("WPFKEY_FRONTEND_REDIRECT_URL", "FRONTEND_REDIRECT_URL");
define("WPFKEY_PROCESSING_REDIRECT_URL", "PROCESSING_REDIRECT_URL");
define("WPFREGEX_PROCESSING_REDIRECT_PARAMETER", "/^PROCESSING_REDIRECT_PARAMETER_(\w+)$/");

define('HPP_QUERY_DO_PREPARE', '/gate/DoPrepare');
define('HPP_QUERY_DO_PAY', '/web/DoPay');
define('HPP_QUERY_DO_CHECKSTATUS', '/gate/GetStatus');

define('CONNECTOR_ATLAS', 'ATLAS');
define('CONNECTOR_BOLETO', 'BOLETO');
define('CONNECTOR_CASHTICKET', 'CASHTICKET');
define('CONNECTOR_CC', 'CC');
define('CONNECTOR_CC3D', 'CC3D');
define('CONNECTOR_CLICKANDBUY', 'CLICKANDBUY');
define('CONNECTOR_DD', 'DD');
define('CONNECTOR_DINEROMAIL', 'DINEROMAIL_ARGENTINA');
define('CONNECTOR_EPS', 'EPS');
define('CONNECTOR_EWATECH', 'EWATECH');
define('CONNECTOR_GIROPAY', 'STARFINANZ_GIROPAY');
define('CONNECTOR_IDEAL', 'IDEAL');
define('CONNECTOR_MILESANDMORE', 'MILESANDMORE');
define('CONNECTOR_MONERIS', 'MONERIS');
define('CONNECTOR_MONEYBOOKERS', 'MONEYBOOKERS');
define('CONNECTOR_PAYPAL', 'PAYPAL');
define('CONNECTOR_PAYSAFECARD', 'PAYSAFECARD');
define('CONNECTOR_POLI', 'POLI');
define('CONNECTOR_PREPAYMENT', 'PREPAYMENT');
define('CONNECTOR_PRZELEWY', 'PRZELEWY');
define('CONNECTOR_RATEPAY', 'RATEPAY');
define('CONNECTOR_SOFORTUEBERWEISUNG', 'SOFORTUEBERWEISUNG');
define('CONNECTOR_TPAY', 'TPAY');
define('CONNECTOR_THOMEPAY', 'THOMEPAY');
define('CONNECTOR_AMAZON', 'AMAZON');
?>